'--------------------------------------------------------------------------------------------------

Device = 12F1840
         
Config1 FOSC_INTOSC, WDTE_OFF, PWRTE_OFF, CP_OFF, CPD_OFF, BOREN_OFF, CLKOUTEN_OFF, IESO_OFF, FCMEN_ON, MCLRE_OFF 'MCLRE_OFF-   ./ MCLRE_ON-   MCLR-Reset 
Config2 WRT_OFF, PLLEN_OFF, STVREN_OFF, LVP_OFF


'---------------------------   -------------------------------------------------

Declare Reminders = OFF           '    
Declare Warnings = OFF            '    
'Declare Optimiser_Level 1        '     ...


'---------------------------    ----------------------------------------                                 
                                  
OSCCON.7 = 1                      ' 4xPLL  (1-/0-) 
 
OSCCON.6 = 1                      '  6-3,   
OSCCON.5 = 1                      ' 1111- 16 
OSCCON.4 = 1                       
OSCCON.3 = 1 
                     
OSCCON.1 = 1                      '    
                                  
OSCTUNE = %000000                 ' %000000 -     
                                  ' %011111 -  
                                  ' %100000 -  
Declare Xtal 16
                                  
                                  
'---------------------------     -----------------------------------                                  
                                  
BORCON.7 = 0                      '     (1-/0-)

                                 
'---------------------------    ---------------------------------------

INTCON.7 = 1                      '    (1-/0-) 
INTCON.6 = 1                      '      (1-/0-) 
INTCON.5 = 0                      '      TMR0(1-/0-)
INTCON.4 = 0                      '     INT(1-/0-)
INTCON.3 = 0                      '       RA(1-/0-)
Symbol INTF = INTCON.1            '    INT ( =1)

PIE1.7 = 0                        '      TMR1 (1-/0-) 
PIE1.1 = 1                        '     TMR2   (1-/0-) 
PIE1.0 = 0                        '     TMR1   (1-/0-)
Symbol TMR1IF = PIR1.0            '    TMR1 (   =1)
Symbol TMR2IF = PIR1.1            '    TMR2 (   =1)

OPTION_REG.6 = 1                  '      RA2/INT (1-  /0- )

On_Hardware_Interrupt INT         '    


'----------------------------   TMR1 ----------------------------------------------

T1CON.5 = 1                       '  5-4,    
T1CON.4 = 1                       ' 11 = 1:8, 10 = 1:4, 01 = 1:2, 00 = 1:1

T1CON.1 = 0                       '     (1-  /0- Fosc/4)
T1CON.0 = 1                       '    TMR1 (1-/0-)

TMR1L = 3036                      '     TMR1,  F(.)=2


'----------------------------   TMR2 ----------------------------------------------
                                   
T2CON.6 = 1                       '  6-3,   
T2CON.5 = 0                       ' 0000=1:1, 0001=1:2,...1001=1:10,...1111=1:16 
T2CON.4 = 0                                                                                       
T2CON.3 = 1

T2CON.2 = 1                       '    TMR2 (1-/0-)

T2CON.1 = 1                       '  1-0,   
T2CON.0 = 0                       ' 00=1:1, 01=1:4, 10=1:16, 11=1:64

PR2 = 250                         '     TMR2,  F(.)=100  


'---------------------------  Eeprom -----------------------------------------------------

EECON1.7 = 0                      '     (0-EEPROM/1-Flash )
EECON1.6 = 0                      '    EEPROM  
EECON1.2 = 1                      '    
                                                

'---------------------------   -----------------------------------------------------

PORTA = %00000000                 '   0    A 
                 
TRISA.5 = 0                       '    RA5-RA0  / (0-,1-)
TRISA.4 = 0                       ' (RA3   ,  MCLR)
TRISA.2 = 0
TRISA.1 = 1
TRISA.0 = 0
                                                    
ANSELA.4 = 0                      '  RA4 (0- /, 1- )
ANSELA.3 = 0                      '  RA3 (0- /, 1- )
ANSELA.2 = 0                      '  RA2 (0- /, 1- )
ANSELA.1 = 0                      '  RA1 (0- /, 1- )
'ANSELA.1 = 1                      '  RA1 (0- /, 1- )
ANSELA.0 = 0                      '  RA0 (0- /, 1- )

OPTION_REG.7 = 0                  ' 1-Pull-up    /0-  

WPUA.5 = 0                        ' Pull-up   RA5(1-/0-)
WPUA.4 = 0                        ' Pull-up   RA4(1-/0-)
WPUA.3 = 1                        ' Pull-up   RA3(1-/0-)
WPUA.2 = 0                        ' Pull-up   RA2(1-/0-)
WPUA.1 = 1                        ' Pull-up   RA1(1-/0-)

Symbol KEY = PORTA.1
Symbol LED = PORTA.2
Symbol RST = PORTA.3


'---------------------------    FVR(Fixed Voltage Reference) -----------

FVRCON.7 = 0                      '  FVR(Fixed Voltage Reference 1.024V) (1-/0-)

FVRCON.3 = 1                      '  3-2,   : 00-FVR(Fixed Voltage Reference) ,
FVRCON.2 = 0                      ' 01=1.024V(x1), 10=2.048V(x2), 11=4.096V(x4)

FVRCON.1 = 1                      '  1-1,   : 00-FVR(Fixed Voltage Reference) ,
FVRCON.0 = 0                      ' 01=1.024V(x1), 10=2.048V(x2), 11=4.096V(x4)


'---------------------------   --------------------------------------------------------  

ADCON0.6 = 0                      '  6-2:   : 
ADCON0.5 = 0                      ' 00000=AN0/RA0
ADCON0.4 = 0                      ' 00001=AN1/RA1
ADCON0.3 = 0                      ' 00010=AN2/RA2
ADCON0.2 = 0                      ' 00011=AN3/RA4                      
ADCON0.0 = 0                      '   (1-/0-)

ADCON1.7 = 1                      ' 1-   10-(1024), 0- 8-(254)                                                                                       
Declare Adin_Res 10               '  10- 1024   

'ADCON1.6 = 0                     '  6-4:      : 
'ADCON1.5 = 0                     ' 001-Fosc/8 ( 8), 101-Fosc/16 ( 16)
'ADCON1.4 = 0                     ' 010-Fosc/32 ( 32)
Declare Adin_Tad 16_FOSC          '      Fosc/16( 16MHz)

ADCON1.1 = 0                      '     : 00=+VDD, 10=external +Vref pin,
ADCON1.0 = 0                      ' 11=internal FVR(Fixed Voltage Reference 1.024V)
        
Declare Adin_Stime 50             '        


'----------------------------    --------------------------------------
    
                                  '  Bit(0/1), Byte(0-255), SByte(-128+127), Word(0-65535),
                                  ' SWord(-32768+32767), DWord(0-4294967295), SDword(-2147483648+2147483647), 
                                  ' Float(32-,+-,  )
Dim SEC1_F As Bit                 '  1    
Dim T As Byte                     '                                                                     
Dim SECUND As Byte                '    
Dim MINUT As Byte                 '  
Dim HOUR As Byte                  '  
Dim DAY As Byte                   '  
Dim X As Byte                     '   
Dim Y As Byte                     '   
  
                             
'==================================================================================================
'------------------------------- --------------------------------------------------
MAIN:

                                  ' 1   
If SEC1_F=1 Then
    LED=0
Else
    If KEY=0 Or RST=0 Then           '   
        LED=0
    Else
        LED=1
    EndIf
EndIf

      
   
'ADC_batt=ADIn 2                   '     (0-1024)  AN2

'If ADC_batt>=512 Then
'    PORTA.4=1
'Else
'    PORTA.4=0    
'EndIf
 
GoTo MAIN


'==================================================================================================
'---------------------------- -------------------------------------------------

INT:                              '   

Disable                           ' disable-enable    ,
                                  '      .
Context Save                      '     

'If INTF = 1 Then                  '        INT     
'    INTF = 0                      ' c     INT,         
'EndIf

If TMR2IF=1 Then                  ' ,     
                                  '    TMR2.    ( ),
    TMR2IF=0                      '      ,
                                  '                                                                       
    T=T+1                
    If T=100 Then                 '   100   1    
        T=0                       
        Toggle SEC1_F             '   1       
        SECUND=SECUND+1 
        If SECUND=60 Then
            SECUND=0
            MINUT=MINUT+1   
            If MINUT=60 Then
                MINUT=0
                HOUR=HOUR+1
                If HOUR=24 Then
                    HOUR=0
                    DAY=DAY+1 
                EndIf  
            EndIf
        EndIf
    EndIf                                          
EndIf 

PR2 = 249                         '    TMR2 ,                                                
                                  '  1                                         
                                   
Context Restore                   '                              
Resume
Enable


